#include "player.h"

using namespace std;

Position::Position()
{
    this->x = -1;
    this->y = -1;
}


Position::Position(int x, int y)
{
    this->x = x;
    this->y = y;
}

Player::Player()
{
    this->position = Position();
    this->direction = Direction::NORTH;
}

void Player::initialisePlayer(Position* position, Direction direction)
{
    this->position = Position(position->x, position->y);
    this->direction = direction;
}

void Player::turnDirection(TurnDirection turnDirection)
{
    if (turnDirection == TurnDirection::TURN_LEFT)
    {
        if (this->direction == Direction::NORTH)
            this->direction = Direction::WEST;
        else if (this->direction == Direction::WEST)
            this->direction = Direction::SOUTH;
        else if (this->direction == Direction::SOUTH)
            this->direction = Direction::EAST;
        else if (this->direction == Direction::EAST)
            this->direction = Direction::NORTH;
    }
    else if (turnDirection == TurnDirection::TURN_RIGHT)
    {
        if (this->direction == Direction::NORTH)
            this->direction = Direction::EAST;
        else if (this->direction == Direction::EAST)
            this->direction = Direction::SOUTH;
        else if (this->direction == Direction::SOUTH)
            this->direction = Direction::WEST;
        else if (this->direction == Direction::WEST)
            this->direction = Direction::NORTH;
    }
    
}

Position Player::getNextForwardPosition()
{
    if (this->direction == Direction::NORTH)
        return Position(this->position.x - 1, this->position.y);
    else if (this->direction == Direction::EAST)
        return Position(this->position.x, this->position.y + 1);
    else if (this->direction == Direction::SOUTH)
        return Position(this->position.x + 1, this->position.y);
    else if (this->direction == Direction::WEST)
        return Position(this->position.x, this->position.y - 1);

    return this->position;
}

void Player::updatePosition(Position position)
{
    this->position = position;
}

void Player::displayDirection()
{
    if (this->direction == Direction::NORTH)
        cout << DIRECTION_ARROW_OUTPUT_NORTH;
    else if (this->direction == Direction::EAST)
        cout << DIRECTION_ARROW_OUTPUT_EAST;
    else if (this->direction == Direction::SOUTH)
        cout << DIRECTION_ARROW_OUTPUT_SOUTH;
    else if (this->direction == Direction::WEST)
        cout << DIRECTION_ARROW_OUTPUT_WEST;
}
